unit unit3;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, TAGraph, TASeries, TADrawUtils, TACustomSeries, TATypes;

type

  { TForm1 }

  TForm1 = class(TForm)
    Chart1: TChart;
    Chart1LineSeries1: TLineSeries;
    procedure Chart1LineSeries1CustomDrawPointer(ASender: TChartSeries;
      ADrawer: IChartDrawer; AIndex: Integer; ACenter: TPoint);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  Math, LazLogger;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
const
  a = 5; //4.7337;
  N = 1000;
var
  s, t, v, v20: Double;
  i: Integer;
  txt: String;
begin
  for i:=0 to N do begin
    t := i/N * 6.0;
    s := (a/2) * t**2;
    v := a*t * 3.6;
    v20 := Round(v/20) * 20;
    if SameValue(v, round(v20), 0.05) and (v > 0) then
      txt := FormatFloat('0', v) + ' km/h'
    else
      txt := '';
    Chart1LineSeries1.AddXY(s, t, txt);
    //DebugLn(Format('i=%d, t=%.3f, s=%.3f, v=%.3f, %s, %.3f', [i, t, s, v, txt, v20]));
  end;
end;

procedure TForm1.Chart1LineSeries1CustomDrawPointer(ASender: TChartSeries;
  ADrawer: IChartDrawer; AIndex: Integer; ACenter: TPoint);
const
  dx = 10;
  dy = 10;
var
  rx, ry: Integer;
  pen: TPen;
begin
  // Hervorgehobener Datenpunkt bei s = 70
  if InRange(TLineSeries(ASender).ListSource.Item[AIndex]^.X, 69.98, 70.02) then begin
    rx := TLineSeries(ASender).Pointer.HorizSize*2;
    ry := TLineSeries(ASender).Pointer.VertSize*2;
    ADrawer.Brush := TLineSeries(ASender).Pointer.Brush;
    ADrawer.Pen := TLineSeries(ASender).Pointer.Pen;
    ADrawer.Polygon([
      Point(ACenter.X, ACenter.Y-ry),
      Point(ACenter.X+rx, ACenter.Y),
      Point(ACenter.X, ACenter.Y+ry),
      Point(ACenter.X-rx, ACenter.Y),
      Point(ACenter.X, ACenter.Y-ry)
    ], 0, 5);
  end;

  // Hervorgehobener Datenpunkt bei s = 90
  if InRange(TLineSeries(ASender).ListSource.Item[AIndex]^.X, 89.98, 90.02) then begin
    rx := TLineSeries(ASender).Pointer.HorizSize;
    ry := TLineSeries(ASender).Pointer.VertSize;
    ADrawer.Brush := TLineSeries(ASender).Pointer.Brush;
    ADrawer.Pen := TLineSeries(ASender).Pointer.Pen;
    ADrawer.Ellipse(ACenter.X-rx, ACenter.Y-ry, ACenter.X+rx, ACenter.Y+ry);
  end;

  // Kringel um die Datenpunkte mit Beschriftung, zusätzlich ein Plus-Symbol
  if TLineSeries(ASender).ListSource.Item[AIndex]^.Text <> '' then begin
    // Leider hat IDrawer keine Möglichkeit, Pen.Width direkt zu verändern...
    pen := TPen.Create;
    try
      pen.Assign(TLineSeries(ASender).Pointer.Pen);
      pen.Width := 2;
      ADrawer.SetBrushParams(bsClear, clNone);
      ADrawer.Pen := pen;
      ADrawer.Ellipse(ACenter.X - dx, ACenter.Y - dy, ACenter.X + dx, ACenter.Y + dy);
    finally
      pen.Free;
    end;
    ADrawer.Pen := TLineSeries(ASender).Pointer.Pen;
    rx := 3 * dx div 4;
    ry := 3 * dy div 4;
    ADrawer.Line(ACenter.X-rx, ACenter.Y, ACenter.X+rx, ACenter.Y);
    ADrawer.Line(ACenter.X, ACenter.Y-ry, ACenter.X, ACenter.Y+ry);
  end;
end;

end.

